#ifndef LABEL_H
#define LABEL_H
#include <queue>
#include <algorithm>

#define LABELBASE 0.0
#define LABELBASEINT 0
#define INDEX2D(i,j) (i*sx+j)


class Labeling{
 public:
  double Label;
  int N,bnum,sx,sy,sz;
  int LabelInt;
  Labeling(){
    LabelInt=LABELBASEINT;
    Label=LABELBASE;
    N=0;
    bnum=0;
  }
  virtual ~Labeling(){
    
  }
  
  
  
  int doLabeling(Image *in){
    
    int i,j;
    sx=in->sx;
    sy=in->sy;
    
    bnum = sx*sy;
    bool *mycheck = new bool[bnum];
    for(i=0;i<bnum;i++)mycheck[i]=true;
    int index=0;
    N=0;
    LabelInt= LABELBASEINT;
    for(i=0;i<sy;i++){
      for(j=0;j<sx;j++){
	if(mycheck[INDEX2D(i,j)]){
	  Labelset(in,i,j,LabelInt,mycheck);
	  LabelInt++;
	  N++;
	}
      }
    }
    delete [] mycheck;mycheck=NULL;
    return N;
  }
  
  
  //8 connected in 2D
  int Labelset(Image *in,int ssy,int ssx,int dLabel,bool *mycheck){
    
    
    std::queue<int> pqueue;
    mycheck[INDEX2D(ssy,ssx)]=false;
    int currentLabel=in->img[ssy][ssx];
    in->img[ssy][ssx]=dLabel;
    int i,j,k;
    Put8(ssy,ssx,in,currentLabel,&pqueue,mycheck);
    
    int popID=-1;
    
    
    while(pqueue.empty() == false){
      
      popID = pqueue.front();
      pqueue.pop();
      
      j = popID % sx;
      i = (popID-j) / sx;
      if((i>=0&&i<sy)&&
	 (j>=0&&j<sx)){
	in->img[i][j]=dLabel;
	Put8(i,j,in,currentLabel,&pqueue,mycheck);
      }else{
	printf("Error ! impossible !! %d %d\n",i,j);
      }
    }
    return 0;
  }
  void Put8(int ssy,int ssx,Image *in,int currentLabel,std::queue<int> *pqueue,bool *mycheck){
    int i,j;
    for(i=ssy-1;i<=ssy+1;i++)
      for(j=ssx-1;j<=ssx+1;j++)
	{
	  if((i>=0&&i<sy)&&
	     (j>=0&&j<sx)){
	    if(mycheck[INDEX2D(i,j)]&&in->img[i][j]==currentLabel){
	      mycheck[INDEX2D(i,j)]=false;
	      (*pqueue).push(INDEX2D(i,j));
	    }
	  }
	}
  }
  void Put4(int ssy,int ssx,Image *in,int currentLabel,std::queue<int> *pqueue,bool *mycheck){
    int i,j;
    for(i=ssy-1;i<=ssy+1;i++)
      for(j=ssx-1;j<=ssx+1;j++) {
	
	if((i>=0&&i<sy)&&
	   (j>=0&&j<sx)){
	  if(i*i+j*j<=1.0)
	    if(mycheck[INDEX2D(i,j)]&&in->img[i][j]==currentLabel){
	      mycheck[INDEX2D(i,j)]=false;
	      (*pqueue).push(INDEX2D(i,j));
	    }
	}
      }
    
  }
  
  

  Labeling(const Labeling& rhs);
  const Labeling &operator=(const Labeling& rhs);

  

};
#undef LABELBASE
#undef INDEX
#undef INDEX2D
#endif
